;=======================================================
;checks level info before modifying
;=======================================================
Modify_External:

	call VerifyCAnimalBuffers
	     test eax,eax
		  jz CAnimal_Buffers_Invalid

	call IsLevelSavedGame
	     test eax,eax
		  jnz Saved_Game_No_Mods

	call SetGameDifficulty
	call ModifyCAnimalInstances
	call SetRandomDinoStartPositions

Saved_Game_No_Mods:

	call DoAT10JUMPMainEmulInit
	call CreateDinoInitialInfo
CAnimal_Buffers_Invalid:

	mov eax,[CAnimal_BUF_SIZE]
	shr eax,2		;set number of instances string for "CANIMAL" cheat
invoke wsprintf,canimal_title,canimal_title_base,eax
	add esp,12
	mov [canimal_title_size],eax

	call FLY_CLOAK_Cheats_Reset
	call EnableInGameKeys

	mov [CounterFirstRun],1
	mov [New_CAnimal_BUF],1 	;create new buffer next time
	and [HINT_NEW_STRING_ADDR],0
	and [Restart_Exit_Level_BOOL],0

ret	;(this marks the end of ATX features used during level load)

;=======================================================
FLY_CLOAK_Cheats_Reset:   ;eax=0 if buffers not OK
;=======================================================
	and [FLY_MODE_BOOL],0

	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;edx = main "Player" class object

	and BYTE [edx+0DDh],0FEh	;disable INVUL

	push 5
	call CHANGEPLAYERTYPE_PROC

EXIT_CHANGEPLAYERTYPE_12322:
ret

;=======================================================
VerifyCAnimalBuffers:	;eax=0 if buffers not OK
;=======================================================
;Note: I don't know the exact size of CAnimal class. This
;routine could be perfected if this exact size was known.

	mov esi,[CANIMAL_VTABLE]
	mov edi,[CAnimal_BUF]
	test edi,edi
	    jz BuffersNotOKorEmpty
	mov ebx,[CAnimal_BUF_SIZE]
	test ebx,ebx
	    jz BuffersNotOKorEmpty
	add ebx,edi

TestCAnimalBuffersMainLoop:

invoke IsBadReadPtr,[edi],0E0h
       test eax,eax
	    jnz BuffersNotOKorEmpty

invoke IsBadWritePtr,[edi],0E0h
       test eax,eax
	    jnz BuffersNotOKorEmpty

       mov eax,[edi]
       cmp [eax],esi		;check if proper VTable is set
	   jnz BuffersNotOKorEmpty

add edi,4
cmp edi,ebx
    jb TestCAnimalBuffersMainLoop

or al,1
ret

BuffersNotOKorEmpty:
       LOCALRELEASE [CAnimal_BUF]
       LOCALRELEASE [CAnimal_Names_INDEX]
       LOCALRELEASE [CAnimal_Names_BUF]
       and [CAnimal_BUF_SIZE],0
       and [CAnimal_Names_BUF_SIZE],0
       xor eax,eax
ret

;=======================================================
CreateDinoInitialInfo:
;=======================================================
LOCALRELEASE [CAnimal_Initial_Info]
and [CAnimal_Initial_Info],0

cmp [CAnimal_BUF],0
    jz NoCreateDinoInitialInfo
mov ebx,[CAnimal_BUF_SIZE]
    test ebx,ebx
	 jz NoCreateDinoInitialInfo

lea ecx,[ebx*8]   ;ecx=(number of instances*4)*8


invoke LocalAlloc,LMEM_FIXED,ecx   ;ecx=(number of instances)*(32 bytes/instance)
       test eax,eax
	    jz NoCreateDinoInitialInfo
mov [CAnimal_Initial_Info],eax

mov edi,eax		      ;Init_info index
mov edx,[CAnimal_BUF]	      ;CAnimal base index
add ebx,edx		      ;limit

CreateDinoInitialInfo_Main_Loop:
	mov esi,[edx]
	add esi,30h
	mov ecx,8
	rep movsd
add edx,4
cmp edx,ebx
    jb CreateDinoInitialInfo_Main_Loop

NoCreateDinoInitialInfo:
ret

;================================================================
ModifyCAnimalInstances:
;================================================================
;CAnimal instance (all) modification code at level start (for HitPoints)
;note: the game does not move the instances' locations in memory (during the period
;between the instancing and this code) so the pointers should
;always be valid

cmp [UseCAnimalHitPoints],0
    jz NoModCAnimalInst
mov esi,[CAnimal_BUF]
sub esi,4
    jb NoModCAnimalInst
mov ebx,[CAnimal_BUF_SIZE]
cmp ebx,4
    jb NoModCAnimalInst
add ebx,esi

	CAnimalModLoop:
	add esi,4
	mov edi,[esi]
	call DoMods_CAnimal
	cmp esi,ebx
	    jb CAnimalModLoop

NoModCAnimalInst:
ret

;================================================================
DoMods_CAnimal: 	;edi=CAnimal instance
;================================================================

;modify instance's health values (updated after each level restart)
;add to HitPoints
	fld DWORD [edi+50h]
	fadd [UseCAnimalHitPoints]
	fstp DWORD [edi+50h]
;add to MaxHitPoints
	fld DWORD [edi+54h]
	fadd [UseCAnimalHitPoints]
	fstp DWORD [edi+54h]
ret
;================================================================