;============================================================
;ActBite code intercept         ;ecx = ActBite object
;============================================================
;IMPORTANT NOTE!!!!!!
;This code is also called upon the "Feint" AI behavior; differentiation
;between the two acts must be done by verifying the object passed in ecx (VTable or signature)

On_ActBite_Main_Code:		;eax and edx may be destroyed

cmp DWORD [ecx+4Ch],'Bite'	;differentiate between ActBite and ActFeint via class signature
    jnz Exit_On_ActBite

cmp [UseDisableActJumpNew],0
    jnz NoActJumpNew_44543
	call ACTJUMPNEW_MAIN
NoActJumpNew_44543:

;============================================================
cmp [UseMXTBITE],0
    jnz do_mxt_bite_main

Exit_On_ActBite:
	pop eax 	;get return address
	sub esp,138h	;replaced code
	jmp eax 	;back to normal biting code

;============================================================
;MatrixTres slowdown        ;radius=sqrt(Xdiff^2 + Ydiff^2 + Zdiff^2)
;============================================================
do_mxt_bite_main:
	push ecx
	push esi
	push ebx
	mov edx,[CAnimal_BUF]
	test edx,edx
	     jz NoMXTOnBiteSimCall
	mov ebx,[CAnimal_BUF_SIZE]
	test ebx,ebx
	     jz NoMXTOnBiteSimCall
	add ebx,edx

	FindDinoForActBiteInstanceLoop:
	mov esi,[edx]
	mov eax,[esi+0DCh]		;instance's main AI sub-class
	cmp ecx,[eax+18h]		;instance's ActBite sub-class
	    jz END_FindDinoForActBiteInstanceLoop
	add edx,4
	cmp edx,ebx
	    jb FindDinoForActBiteInstanceLoop
	    jmp NoMXTOnBiteSimCall

	END_FindDinoForActBiteInstanceLoop:

	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;player object

	fld DWORD [esi+30h]	;dino's X position
	fsub DWORD [edx+30h]	;player's X pos
	fmul st0,st0		;Xdiff^2

	fld DWORD [esi+34h]	;dino's Y position
	fsub DWORD [edx+34h]	;player's Y pos
	fmul st0,st0		;Ydiff^2

	fld DWORD [esi+38h]	;dino's Z position
	fsub DWORD [edx+38h]	;player's Z pos
	fmul st0,st0		;Zdiff^2
	fadd st0,st1		;Zdiff^2+Ydiff^2
	fadd st0,st2		;Zdiff^2+Ydiff^2+Xdiff^2

	fsqrt			;sqrt(Xdiff^2 + Ydiff^2 + Zdiff^2)
	fcomp [UseMXTRadius]
	fstsw ax
	fstp st0
	fstp st0

	test ax,0100010100000000b
	     jz NoMXTOnBiteSimCall

	mov ecx,AT100SimulatedObject
	call AT100MAIN

NoMXTOnBiteSimCall:
	pop ebx
	pop esi
	pop ecx

	pop eax
	sub esp,138h
	jmp eax

